from tdgl import animator,viewgroup,lighting,objpart
from tdgl.animator import interpolator
from tdgl.viewgroup import glDisable, GL_LIGHT0
from OpenGL import GL

class Sequencer(object):
    """ interpolate between a series of values """
    def __init__(self,xlist,steplist):
        self.xlist = xlist
        self.steplist = steplist
        self.interp = interpolator(xlist[0],xlist[1],steplist[0])
        self.step(0)

    def step(self,ms):
        self.interp.step(ms)
        self.current = self.interp.current
        xlist = self.xlist #bugfix
        steplist = self.steplist #bugfix
        if self.interp.finished() and steplist:
            xlist[:1] = []
            steplist[:1] = []
            if len(xlist) > 1: #bugfix
                self.interp = interpolator(xlist[0],xlist[1],steplist[0])
        return self.current

    def finished(self):
        return not self.steplist # bugfix

def viewgroup_setdown_style(vg):
    glDisable(GL_LIGHT0 + vg.light)
    lighting.light_switch(vg.light,False)

def viewgroup_setup_style(vg):
    lighting.light_switch(vg.light,True)
    lighting.setup()

def WFObj_del(obj):
    if GL and GL.glDeleteLists:
         for dl in obj.mesh_dls.values():
            GL.glDeleteLists(dl,1)
 

def patch():
    animator.Sequencer = Sequencer
    viewgroup.setdown_style = viewgroup_setdown_style
    viewgroup.setup_style = viewgroup_setup_style
    objpart.WFObj.__del__ = WFObj_del

"""
Quotes:

badger: A turn doesn't count as a move does it?
acav: Yeah. Program steps.
badger: You can do it that way but people won't like it...
scav: Then they can f*ck off.

- - -

scav: I feel another monkey patch coming on.
Louise: Tell me I didn't hear what I just thought I heard.
Joe: Is that what you're replacing your hair with, monkey patches?

"""
